/*
 * Support for executing code in new tasks and threads.
 *
 * Copyright (C) 2022, 2023 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <exec/process_creating.h>
#include <fsserver/resource.h>

#include "process_creator_interface.h"



/* Process creator. */

class ProcessCreatorResource : public Resource, public ProcessCreator
{
protected:
  ProcessCreating _creating;

public:
  explicit ProcessCreatorResource(const char *rm_filename);

  virtual ~ProcessCreatorResource();

  /* Server details. */

  ipc_server_default_config_type config();

  void *interface()
  { return static_cast<ProcessCreator *>(this); }

  /* Process creator interface methods. */

  virtual long start(l4_cap_idx_t program, l4_cap_idx_t *process);
};

/* vim: tabstop=2 expandtab shiftwidth=2
*/
